--- update/variables/update.orig.py	2015-10-15 10:56:57.784173495 +0300
+++ update/variables/update.py	2015-10-15 11:23:22.998764486 +0300
@@ -261,6 +261,12 @@
               "cl_update_binhost_revisions",
               "cl_update_binhost_time"]
 
+    def urlopen(self, fn, timeout=5):
+        p = process('/usr/bin/curl', '--proxy', "http://10.1.0.1:3128", '--connect-timeout', str(timeout), fn)
+        if p.success():
+            return p
+        raise urllib2.URLError(str(p.cacheerr).strip())
+
     def check_binhost(self, binhost):
         revision_files = [path.join(binhost, x)
                           for x in self.Get('cl_update_binhost_revision_path')]
@@ -269,11 +275,12 @@
             data = None
             for fn in revision_files:
                 if data is None:
-                    data = urllib2.urlopen(fn, timeout=timeout).read()
-                elif data != urllib2.urlopen(fn, timeout=timeout).read():
+                    data = self.urlopen(fn, timeout=timeout).read()
+                elif data != self.urlopen(fn, timeout=timeout).read():
                     return ""
             return data
-        except urllib2.URLError:
+        except urllib2.URLError as e:
+            print str(e)
             return ""
 
     re_revison = re.compile("\w+=(\w+)")
@@ -297,13 +304,15 @@
                                    self.Get('cl_update_binhost_timestamp_path'))
         try:
             t = time.time()
-            data = urllib2.urlopen(timestamp_file,
+            data = self.urlopen(timestamp_file,
                                    timeout=timeout).read().strip()
             if data.isdigit() and t - int(data) < 5 * DAY:
                 return data, int((time.time() - t)*1000)
         except urllib2.URLError as e:
+            print str(e)
             pass
         except BaseException as e:
+            print str(e)
             pass
         return "", -1
 
